



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>osg(OpenSceneGraph)学习笔记1：智能指针osg::ref_ptr&lt;&gt;</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">osg(OpenSceneGraph)学习笔记1：智能指针osg::ref_ptr&lt;&gt;</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-10 01:26:36 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h4>OSG的智能指针，osg::ref_ptr&lt;&gt;</h4>
<p><strong>osg::Referenced</strong>类管理引用计数内存块，osg::ref_ptr需要使用以它为基类的其它类作为模板参数。</p>
<p><strong>osg::ref_ptr&lt;&gt;</strong>类模板重新实现了一系列C++重载符和成员函数，主要有：</p>
<ul><li>T* get(): 返回管理的指针, { return _ptr; }</li>
<li>T&amp; operator*(): 返回间接引用，{ return *_ptr; }</li>
<li>T* operator-&gt;():&nbsp; { return _ptr; }</li>
<li>operator=(): 各种赋值</li>
<li>operator==(), operator!=(), and operator!():</li>
<li>valid(): { return _ptr!=0; }</li>
<li>release():</li></ul>
<h4>简单示例：</h4>
<div>
<pre class="prettyprint linenums">#include &lt;osg/ref_ptr&gt;<br />
#include &lt;osg/Referenced&gt;<br />
#include &lt;iostream&gt;

class MonitoringTarget : public osg::Referenced<br />
{<br />
public:<br />
    MonitoringTarget(int id) : _id(id)<br />
    {<br />
        std::cout &lt;&lt; "构造目标 " &lt;&lt; _id &lt;&lt; std::endl;<br />
    }<br />
protected:<br />
    virtual ~MonitoringTarget()<br />
    {<br />
        std::cout &lt;&lt; "目标销毁 " &lt;&lt; _id &lt;&lt; std::endl;<br />
    }

    int _id;<br />
};

int main(int argc, char *argv[])<br />
{<br />
    osg::ref_ptr&lt;MonitoringTarget&gt; target = new MonitoringTarget();<br />
    std::cout &lt;&lt; "引用前引用计数为: "<br />
        &lt;&lt; target-&gt;referenceCount() &lt;&lt; std::endl;<br />
    osg::ref_ptr&lt;MonitoringTarget&gt; anotherTarget = target;<br />
    std::cout &lt;&lt; "引用后引用计数为: "<br />
        &lt;&lt; target-&gt;referenceCount() &lt;&lt; std::endl;<br />
    for (unsigned int i = ; i&lt;; ++i)<br />
    {<br />
        osg::ref_ptr&lt;MonitoringTarget&gt; subTarget =<br />
            new MonitoringTarget(i);<br />
    }<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k4j759.html">linux安装软件的学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4v4d0q.html">Aptana Studio 2启动时提示 Workspace Cannot Be Created 解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx3k4jq.html">BackTrack 5 开启SSHD服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq131148.html">解决mysql&OpenCurlyDoubleQuote;Access denied for user &amp;&num;39&semi;root&amp;&num;39&semi;&commat;&amp;&num;39&semi;localhost&amp;&num;39&semi;&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qymk0jq.html">Recon-Erlang线上系统诊断工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y3rojq.html">flash Timer类使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvyen1q.html">mongodump备份数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljkx0k9.html">016 多对多关联映射 单向&lpar;many-to-many&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpk1yjq.html">获取本机IP&lpar;适用于Linux系统&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpxxrjq.html">Slf4j与其他日志系统兼容的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1j4ldq.html">Linux常用命令&lpar;第二版&rpar; --压缩解压缩命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoz3d3q.html">WebGL three&period;js学习笔记 创建three&period;js代码的基本框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1kznjq.html">MySQL学习笔记（七）使用AutoMySQLBackup工具自动备份MySQL数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e43ydx9.html">Codeforces Beta Round &num;19C&period; Deletion of Repeats</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j3z4nq.html">深度学习原理与框架-Alexnet&lpar;迁移学习代码&rpar;  1&period;sys&period;argv&lbrack;1&colon;&rsqb;&lpar;控制台输入的参数获取第二个参数开始&rpar; 2&period;tf&period;split&lpar;对数据进行切分操作&rpar; 3&period;tf&period;concat&lpar;对数据进行合并操作&rpar; 4&period;tf&period;variable&lowbar;scope&lpar;指定w的使用范围&rpar; 5&period;tf&period;get&lowbar;variable&lpar;构造和获得参数&rpar; 6&period;np&period;load&lpar;加载&period;npy文件&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwxnjx9.html">swift class的缺省基类（SwiftObject）与内存模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwe04z8.html">03 Zabbix4&period;0添加cisco交换机基本监控步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnmzd2q.html">红黑树插入与删除完整代码（dart语言实现）</a>
		</li>
						<li><a href="https://www.batexi.com/a/902vrdjq.html">【COGS2479】 HZOI2016&mdash;偏序</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppj0d49.html">Eclipse常见设置与操作</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qvvnlr1q.html">java中synchronized使用方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vlg038.html">URAL - 1736 - Chinese Hockey</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm746x9.html">&lbrack;Angular 2&rsqb; Handle Reactive Async opreations in Service</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydxz52q.html">Java生成word文档</a>
			</li>
						<li><a href="https://www.batexi.com/a/96ogv2v9.html">JVM专题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1xd119.html">C&plus;&plus; ORM ODB 入门介绍（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xkezr9.html">TCPDUMP Command Examples</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjez6z9.html">IP地址基础知识</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1znm269.html">SharePoint 文档库实现文件夹拖放到文档库</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1kj3j8.html">php注册登录时生成的验证码</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
